/* Represents an undirected graph.
 * Also contains the vertex and edge classes
 * vertexes know their center point on the SDL Surface - 
 * bad decoupling maybe, but not too bad, all things considered
 */

#ifndef _GRAPH_H_
#define _GRAPH_H_

#include <list>

using std::list;

class Vertex
{
  public:
    Vertex(int x, int y, int r);

    int x;
    int y;
    int r;
};

struct Edge
{
    Vertex* a;
    Vertex* b;
};

class Graph
{
 public:
    Graph();
    ~Graph();

    bool vertex_present(int x, int y, int size);

    list<Vertex*> get_vertices() { return vertices; }
    list<Edge> get_edges() { return edges; }

    void select_vertex(int x, int y);
    void do_vertex(int x, int y, int r);
    Vertex* get_current_vertex() { return current_vertex; }

 private:
    bool vertex_would_overlap(int x, int y, int r);
    bool crosses_edge(Edge e);
    void add_vertex(int x, int y, int r);

    Vertex* current_vertex;
    list<Vertex*> vertices;
    list<Edge> edges;
};

#endif
